/***************************************************************************
 *            SimTL.h
 *
 *  Mon Apr 21 20:13:55 2008
 *  Copyright  2008  pchero21
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

// GCC 컴파일 옵션 : gcc -o SimTL_beta -I./ -lpcap SimTL.c SimTL_beta.c


#ifndef SIMTL_H
#define SIMTL_H
 
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <pcap.h>
#include <net/ethernet.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>

#define PROMISCUOUS 1

struct printer {
	pcap_handler f;
	int type;
};

typedef struct pcap_options {
	char *filter_rule;	// 필터 룰
	char *device;		// 디바이스
	int pflag;      // DATA를 문자로 찍을 것인지.
	int rflag;      // DATA를 생으로 찍을 것인지.
	int eflag;     // DATALINK layer print option
	int fflag;		// Ethernet Frame print option
	int cflag;     // 패킷을 이 숫자만큼 찍어주고 종료한다.
	FILE *fd_pckList;		// 패킷 리스트 파일 기술자
	int packetcnt;		// 캡처할 패킷의 수
	int chcnt;    		// 캡처한 패킷의 수
	int argc;				// 옵션의 갯수
	//char *argv[];		// 옵션 내용
} pcap_option;	

pcap_option *p_option;

/* 현재 시각을 기준으로 파일을 만들어 파일 기술자를 리턴 */
FILE *make_tmpfile(FILE *fd_dir);

/* 임시 디렉토리를 만들고 디렉토리 관리 파일을 생성 */
void make_tmpdirec(void);

/* 패킷을 잡는 pcap 함수*/
int packet_capture(pcap_option *pcap_option);

/* 패킷을 분석하는 packet_analysis */
void packet_analysis(unsigned char *, const struct pcap_pkthdr *, const unsigned char *);

/* DataLink Type 에 따라 수행될 함수를 결정하는 lookup_printer */
static pcap_handler lookup_printer(int type);

/* Signal 설정 */
void sig_int(int sig);

/* 사용법 설명 */
void usage(void);

/* 옵션 거르기 */
void get_option(char **argv, pcap_option *p_option);

/* 저장 여부를 물어보고 저장을 시도한다. */
void tmp_save(void);

static struct printer printers[] = {
	{packet_analysis, DLT_IEEE802},
	{packet_analysis, DLT_EN10MB},
	{NULL, 0},
};

#endif
